# mkflat -- To make super-flat
# Created: Yoshifusa Ita, 25-Jan-05

procedure mkflat (ircconst, verbose)
string  mode="al"

string ircconst     {"constants.database", prompt="IRC constants database file name"}
int    max_itr      {10,min=1,max=10, prompt="Maximum number of iterations"}
real   sig_rej      {2.,min=0.,max=100., prompt="Number of sigmas for imstat limits"}
bool   verbose = no {prompt="Print verbose progress messages?\n"}
bool   deltemp = yes    {prompt="Delete intermediate files?"}
struct *list0
struct *list1

begin

 string fname, finput, foutput, lname, sname, tmp1, tmp2, datafilename
 bool verb
 int i, maxitr, naxis, naxis1, naxis2, naxis3
 string filter, exec, pcommand, libpath, irc_const
 string maskfile, nmask, smask, lmask
 string prefix, ndark, sdark, ldark, listname
 string imgarea, logfile
 int det, num, npix
 real lower, upper, ll, ul, sigrej
 real mean, median, modee, sigma
 real m_median, m_sigma, lthresh, hthresh
 real m_median2, m_sigma2
 bool self_dark, deltmp


 print ("\n")
 print ("### MKFLAT ###\n")

# get query parameters
 sigrej = sig_rej
 maxitr = max_itr
 irc_const = ircconst
 verb = verbose
 pcommand = osfn ("ircperl$")
 exec = osfn("ircbin$")
 libpath = osfn ("irclib$")
 logfile = "irclog" 
 deltmp = deltemp

# list$B$r:n$k(B
# ! ls -1 dslnDwaF*_N002.fits     > nir_long.list
# ! ls -1 dslnDwaF*_S00[2-4].fits > mrs_long.list
# ! ls -1 dslnDwaF*_L00[2-4].fits > mrl_long.list
# ! ls -1 slnDwaF*_N002.fits     > nir_long.list
# ! ls -1 slnDwaF*_S00[2-4].fits > mrs_long.list
# ! ls -1 slnDwaF*_L00[2-4].fits > mrl_long.list
! echo CnDaF*_N002.fits | xargs ls -1 > nir_long.list


# $B%U%#%k%?JL$K%$%s%W%C%H%U%!%$%k$r:n$k(B
# NIR
 if( access("header_temp") ) { delete("header_temp", ver-) }
 hselect("@nir_long.list", fields="$I,FILTER", expr="yes", >> "header_temp")
 ! awk '{print $1,$2}' header.tmp | sed -n '/N2\|N3\|N4/p' > temp.list
 printf("! wc -l temp.list\n") | cl | scan(num, tmp1)
 tmp2 = exec//"mkflatpair"
 printf("! %s %s %d\n", tmp2, tmp1, num) | cl
 if( access("temp.list") ) { delete("temp.list", ver-) }
 if( access("header_temp") ) { delete("header_temp", ver-) }
 delete("???_long.list")
 if( access("dame.list") ) { delete("dame.list", ver-) }

 ! ls -1 *.list > master.dat

 noao
 imred
 ccdred
 print ("Now making flat images...\n")
 list1 = "master.dat"
 while( fscan(list1, listname) !=EOF){
	 num = 0
	 m_median = 0.0
	 m_sigma  = 0.0
	 lower = 0.0
	 upper = 500.0
	 list0 = listname
	 # sky$B$N%l%Y%k$rD4$Y$k(B
	 if( access("data.tmp") ){ delete("data.tmp", ver-)}
	 while( fscan(list0, fname, filter) !=EOF){
		# IMAGING AREA 
		if(filter=="N2"||filter=="N3"||filter=="N4"){
			imgarea = "[1:412,1:384]"
			if( access("mask.pl") ){ imdel("mask.pl", ver-)}
			if( access("tmp.fits") ){ imdel("tmp.fits", ver-)}
			if( access("mask.fits") ){ imdel("mask.fits", ver-)}
			# $B@1$r%^%9%/$9$k!#(B
			makemask (fname, "mask", hinlist="", subsample=1, checklimits=yes, zmin=lower, zmax=upper, filtsize=15, nsmooth=3, statsec=imgarea, nsigrej=10., maxiter=20, threshtype="nsigma", nsigthresh=2., constthresh=0., negthresh=no, ngrow=0, verbose=verb, imglist="", outimglist="", hdrimglist="")
			# $B$G$-$?(Bmask.pl$B$O(B0$B$,(Bsky$B$G!"(B1$B$,@1$K$J$C$F$k$+$iH?E>$5$;$k!#$a$s$I$/$5$$$J$!!#8-$$$d$j$+$?$J$$$+$J$!!#(B
			imarith ("mask.pl", "-", 1, "tmp.fits", title="", divzero=0., hparams="", pixtype="integer", calctype="integer", verbose=verb, noact=no)
			imarith ("tmp.fits", "*", -1, "mask.fits", title="", divzero=0., hparams="", pixtype="integer", calctype="integer", verbose=verb, noact=no)
			# $BH?E>$5$;$?%^%9%/$r$+$1$k!#(B
			imarith (fname, "*", "mask.fits", fname, title="", divzero=0., hparams="", pixtype="double", calctype="double", verbose=verb, noact=no)
		}else if(filter=="S7"||filter=="S9W"||filter=="S11"){
			imgarea = "[30:256,1:256]"
		}else if(filter=="L15"||filter=="L18W"||filter=="L24"){
			imgarea = "[1:236,1:256]"
		}else{
			imgarea = "[1:256,1:256]"
		}
		imstat(fname//imgarea, fields="npix,mean,midpt,mode,stddev", lower=lower, upper=upper, nclip=0, binwidth=0.1, format=no, cache=no) | scan(npix, mean, median, modee, sigma)
		i = 0
	        while(i < maxitr){
	                ll = mean - (sigrej*sigma)
	                ul = mean + (sigrej*sigma)
	                if (lower != INDEF && ll < lower) ll = lower
	                if (upper != INDEF && ul > upper) ul = upper
	                imstat(fname//imgarea, fields="npix,mean,midpt,mode,stddev", lower=ll, upper=ul, nclip=0, binwidth=0.1, format=no, cache=no) | scan(npix, mean, median, modee, sigma)
	                i += 1
	        }
		# printf("debug: %s %s %d %f %f %f %f\n", "m"//fname, filter, npix, mean, median, modee, sigma)
		printf("%s %d %f %f %f %f\n", "m"//fname, npix, mean, median, modee, sigma, >> "data.tmp")
	 }

	 # ! awk '{x[NR]=$4; u[NR]=$6}END{n=int((NR+1)/2);if(NR%2==1){print x[n],u[n]}else{print (x[n]+x[n+1])/2, (u[n]+u[n+1])/2}}' data.tmp > data

	 ! awk '{print $4}' data.tmp | /irafaddin/irc/perl/median-sh > median
	 ! awk '{print $4}' data.tmp | /irafaddin/irc/perl/stdev-sh  > stdev
	 print("! cat median\n") | cl | scan (m_median)
	 print("! cat stdev\n") | cl | scan (m_sigma)

	 # $BJQ$J%$%a!<%8$O%j%9%H$+$i<h$j=|$$$F!"3F2hA|Kh$K!"%b!<%I$G3d$C$F5,3J2=(B
	 num = 0
	 m_median2 = 0.0
	 m_sigma2  = 0.0
	 lower = 0.0
	 upper = 1000.0
	 list0 = listname
	 if( access("ok.list") ) { delete("ok.list", ver-) }
	 while( fscan(list0, fname, tmp1) !=EOF){
		# IMAGING AREA 
		if(tmp1=="N2"||tmp1=="N3"||tmp1=="N4"){
			imgarea = "[1:412,1:384]"
		}else if(tmp1=="S7"||tmp1=="S9W"||tmp1=="S11"){
			imgarea = "[29:256,1:256]"
		}else if(tmp1=="L15"||tmp1=="L18W"||tmp1=="L24"){
			imgarea = "[1:236,1:256]"
		}else{
			imgarea = "[1:256,1:256]"
		}
	 	imstat(fname//imgarea, fields="npix,mean,midpt,mode,stddev", lower=lower, upper=upper, nclip=0, binwidth=0.01, format=no, cache=no) | scan(npix, mean, median, modee, sigma)
		i = 0
	        while(i < 10){
	                ll = mean - (sigrej*sigma)
	                ul = mean + (sigrej*sigma)
	                if (lower != INDEF && ll < lower) ll = lower
	                if (upper != INDEF && ul > upper) ul = upper
	                imstat(fname//imgarea, fields="npix,mean,midpt,mode,stddev", lower=ll, upper=ul, nclip=0, binwidth=0.01, format=no, cache=no) | scan(npix, mean, median, modee, sigma)
#			printf("debug2: %s %s %d %f %f %f %f\n", fname, filter, npix, mean, median, modee, sigma)
	                i += 1
	        }
#		if( (median < m_median + sigrej*m_sigma) && (median > m_median - sigrej*m_sigma) ){
		printf("debug3: %f %f mode=%f\n",m_median, m_sigma, modee)
		if( (median < m_median + sigma) && (median > m_median - sigma) && (sigma < 20) && (modee > 5.0) ){
			if( access("m"//fname) ) { imdel("m"//fname, ver-) }
			imarith(fname, "/", modee, "m"//fname, title="", divzero=0., hparams="", pixtype="", calctype="", verbose=verb, noact=no)
			imstat("m"//fname//imgarea, fields="npix,mean,midpt,mode,stddev", lower=0.5, upper=1.5, nclip=0, binwidth=0.01, format=no, cache=no) | scan(npix, mean, median, modee, sigma)
			if (npix > 9999){
				printf("%s\n", "m"//fname, >> "ok.list")
				printf("%s %d %f %f %f %f\n", "m"//fname, npix, mean, median, modee, sigma, >> filter//".dat")
				m_median2 += median
				m_sigma2  += sigma
				num += 1		
			}
		}else{
			printf("%s %f %f\n", "m"//fname, median, modee, >> "dame.list")
		}

	 }
	 m_median2 /= num
	 m_sigma2  /= num

	 # coadd$B$9$k(B
	 lthresh = m_median2 - sigrej*m_sigma2
	 hthresh = m_median2 + sigrej*m_sigma2
	 printf ("Making flat field for %s\n",filter)
	 if( access(filter//".fits") ) { imdel(filter//".fits", ver-) }
	 if( access("sigma_"//filter//".fits") ) { imdel("sigma_"//filter//".fits", ver-) }

	 combine ("@ok.list", filter//".fits", plfile="", sigma="sigma_"//filter//".fits", ccdtype="", subsets=no, delete=no, clobber=no, combine="median", reject="sigclip", project=no, outtype="double", offsets="none", masktype="none", maskvalue=0., blank=0., scale="none", zero="none", weight="none", statsec=imgarea, lthreshold=0.5, hthreshold=1.5, nlow=1, nhigh=1, nkeep=1, mclip=yes, lsigma=sigrej, hsigma=sigrej, rdnoise="0.", gain="1.", snoise="0.", sigscale=0.1, pclip=-0.5, grow=0)
#	 imdel("@ok.list", ver-)

#	 if( access("ok.list") ) { delete("ok.list", ver-) }
 }

# delete("@master.dat", ver-)
# delete("master.dat", ver-)
# delete("logfile", ver-)

 print("### MKFLAT finished!! ###\n")

 imstat("N*.fits[1:412,1:384]", fields="image,npix,mean,stddev,min,max", lower=INDEF, upper=INDEF, nclip=10, binwidth=0.1, format=yes, cache=no) 
 imstat("sigma_N*.fits[1:412,1:384]", fields="image,npix,mean,stddev,min,max", lower=INDEF, upper=INDEF, nclip=10, binwidth=0.1, format=yes, cache=no) 


end
