# prepipeline.cl -- IRC imaging data reduction pre-pipeline task
# Created: Yoshifusa Ita, 01-Jul-05
# 02-Jul-05 - Add redbox.ircslice (Y. Ita)
# 14-Jul-05 - Add redbox.mkirclog (Y. Ita)
# 11-May-06 - Add lines to comment out dark and spectroscopic data (Y. Ita)
# 26-Jan-10 - patch release for 2010 problem. (T.WADA)

procedure prepipeline

string  ircconst     {"constants.database", prompt="IRC constants database file name"}
bool 	verbose = no {prompt="Print verbose progress messages?\n"}
string  mode="al"

struct *list1


begin
 string logfile, irc_const, pcommand
 bool verb
 int status, date

 print ("\n")
 print ("### PRE-PIPELINE ###\n")

# get query parameter
 irc_const = ircconst
 verb = verbose

# check if the data is taken after fixing detector operation parameters
# i.e. AFTER 2008/03/20
# ! cat ../rawdata/README* | grep 200 | sed -e '/J2000/d' | sed -e '/Ecliptic/d' | sed -e '/NULL/d' | tr '-' '0' | awk '{print $1}' > obsdate
#! cat ../rawdata/Pointing_tbl.dat | grep DateTime | perl -ne 's/-/0/g;split;print $_[1]' > obsdate
#! cat ../rawdata/README* | grep 201 | sed -e '/J2000/d' | sed -e '/Ecliptic/d' | sed -e '/NULL/d' | tr '-' '0' | awk '{print $1}' > obsdate
! cat ../rawdata/Pointing_tbl.dat | grep DateTime | perl -ne 'chomp;s/-/0/g;split;printf("%s\n",$_[1])' > obsdate
 date = 0
 list1 = "obsdate"
 status = fscan(list1, date)
 if(date < 2008003020){
	print ("### !!! CAUTION !!! CAUTION !!! CAUTION !!! ###")
	print ("###                                         ###")
	print ("### This pipeline is for PHASE-3 data ONLY, ###")
	print ("### and CAN NOT handle PHASE 1 nor 2 DATA.  ###")
	print ("###                                         ###")
	print ("### !!! CAUTION !!! CAUTION !!! CAUTION !!! ###")
	print ("\n")
	! \rm -rf obsdate
	bye
 }else{
	! \rm -rf obsdate
 }


# ircslice
 ircslice(irc_const, verb)

# make irclog
 mkirclog(irc_const, verb)

# comment out dark and spectroscopy data
# for gnu sed only
# ! cat irclog | sed -e '/ DARK \| NP \| NG \| SG1 \| SG2 \| LG1 \| LG2 \| UNDEF /s/^/#/' > tmp
# for all sed
 ! cat irclog | sed -e '/ DARK /s/^/#/' -e '/ NP /s/^/#/' -e '/ NG /s/^/#/' -e '/ SG1 /s/^/#/' -e '/ SG2 /s/^/#/' -e '/ LG1 /s/^/#/' -e '/ LG2 /s/^/#/' -e '/ UNDEF /s/^/#/' > tmp
 ! \mv tmp irclog

 print ("\n")
 print ("### PRE-PIPELINE finished!! ###\n")
 print ("\n\n")
 print ("######\n Please edit \"irclog\" before running pipeline! \n######")
 print ("\n\n")


# make dark list
 pcommand = osfn ("ircperl$")
 pcommand = pcommand//"darklist.pl"
 printf("! %s irclog\n",pcommand) | cl


# check if the irclog is correct
 pcommand = osfn ("ircperl$")
 pcommand = pcommand//"checkirclog.pl"
 printf("! %s\n",pcommand) | cl

end
